#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request; 

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

###### CRAWL GOOGLE URLS

print "Content-type: text/html\n\n"; 

$threads = $q->param('threads');
$timeout = $q->param('timeout');
$googlenr = $q->param('googlenr');
$keywords = $q->param('keywords'); $keywords =~ s/ /+/g;
$ccid = $q->param('ccid');

$metadiz = $q->param('metadiz');
$metakeyw = $q->param('metakeyw');

$nrfiles = $q->param('nrfiles');
$lastpos = $q->param('lastpos');
if ($lastpos eq "") { $lastpos = 0; }


####################################

$google_file = "G_" . $lastpos . "_" . $ccid . ".gle";

my (@kid_pid);

$glinks = acs::get_file_contents("$data_dir/crawler/$google_file"); 

my @all_glinks = split (/\n/, $glinks);



foreach $item (@all_glinks)
{
($gnr, $google_lnk) = split (/:---:/, $item);

	#defined(my $childpid = fork) or die "Cannot fork: $!";
	#if ($childpid) ### IF PARENT
	
	if( my $childpid = fork() )
		{
			push( @kid_pid, $childpid );
	   }
		else #### CHILD PROCESS FETCHING GOOGLE PAGES
		{

			open STDIN, "</dev/null";
			open STDOUT, ">/dev/null";
			
			my $ua = LWP::UserAgent-> new();
			$ua->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); # give it time, it'll get there
			$ua->timeout($timeout);
			my $req = HTTP::Request->new(GET => "$google_lnk"); 
			my $response = $ua->request($req);

			if ($response->is_success) 
				{
		  		
				my $content = $response->content();
				$c_filename = $gnr . "." . $ccid;
				open (TT2, "> $data_dir/crawler/$c_filename");
				print TT2 "$google_lnk" . "\n\n\n" . $content;
				close (TT2);
			
				#$content = acs::get_file_contents("$data_dir/crawler/$c_filename"); 
	
				### EXTRACT URLS FROM GOOGLE PAGE FETCHED
				$chc = chr(34);
				$splitcrit = "href=" . $chc;
				my @allurls = split (/$splitcrit/, $content);
				$all_urls = "";
				foreach $sitem (@allurls)
					{
					my @httpitems = split (/$chc/, $sitem);
					
							if ((substr($httpitems[0],0,7) eq "http://") and ($httpitems[0] !~ /google\.com/) and  ($httpitems[0] !~ /search\?q=cache/))
								{
								$all_urls = $all_urls .  $httpitems[0] . "\n";
								}
					}

				open (URLS, ">> $data_dir/crawler/$ccid" . "_" . $gnr . "_.urls");
					print URLS $all_urls;
				close (URLS);
				
				}
				
			exit;

		}

	$i++;
	}

foreach $piditem (@kid_pid)
	{
	waitpid($piditem,0);
	}  





#####################################

$lastpos++;

if ($lastpos <= $nrfiles)
{

if ($lastpos > 0)
	{
	$perc = ($lastpos / $nrfiles) * 100;
	$perc = sprintf("%5.2f",$perc); 
	}
	else
	{
	$perc = 100;
	}


$randomnumber = rand(10); 
$randomnumber = int($randomnumber);
if($randomnumber eq 0) { $randomnumber = 3; }



$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Crawling Google For Links...", qq[
Fetching Pages... Please Wait...
]);



print qq[
<html>
<head>
<title>Crawler</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="$randomnumber;URL=$admin_url/pcrawl3.cgi?threads=$threads&timeout=$timeout&googlenr=$googlenr&keywords=$keywords&ccid=$ccid&nrfiles=$nrfiles&lastpos=$lastpos&metadiz=$metadiz&metakeyw=$metakeyw">
</head>
<body>

$hbox

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="5%" valign="middle"><p align="center"><img src="$web_url/working.gif"></td>
    <td width="20%" valign="middle" align="center"><strong class="normaltext">$perc % Complete</strong></td>
    <td width="75%" height="27">

<table border="0" cellpadding="0" cellspacing="0" width="$perc%">
  <tr>
    <td width="100%" height="30" background="$web_url/bar.gif"></td>
  </tr>
</table>

    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>


</body>
</html>
]; 


#-----------------<BR><BR>
#<b>$google_file</b><BR>
#threads $threads<BR>
#timeout $timeout<BR>
#googlenr $googlenr<BR>
#keywords $keywords<BR>
#ccid $ccid<BR>
#nrfiles $nrfiles<BR>
#lastpos $lastpos<BR>
#------------------<BR><BR>


}
else ### IF CRAWL OPERATION IS FINISHED
{

opendir(DIR,"$data_dir/crawler");
@files = readdir(DIR);
closedir(DIR);


foreach $filename (@files)
	{
	
	($apart, $nf_ccid) = split (/\./, $filename);
	
	if (substr($filename, length($filename) - 3, 3) eq "gle")
		{ 
		($gtmp, $tmn, $ff_ccid) = split (/_/, $filename);
		$ff_ccid =~ s/\.gle//g;
		if ($ff_ccid eq $ccid)
			{
			$tmp = unlink("$data_dir/crawler/$filename"); 
			}
		
		}
		elsif ($nf_ccid eq $ccid)
		{
		$tmp = unlink("$data_dir/crawler/$filename"); 
		}
	
	}


### CHECK IF WE GOT SOMETHING FROM GOOGLE

#open (URLS, ">> $data_dir/crawler/$ccid" . "_" . $gnr . "_.urls");

opendir(DIR,"$data_dir/crawler");
@crawled_urls = readdir(DIR);
closedir(DIR);

foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq "urls")
		{ 
		($the_cid, $tmp, $tmp2) = split (/_/, );
		$found_google_crawled_urls = "true";
		}
	}




if ($found_google_crawled_urls eq "true")
{

$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Preparing to Crawl Web Sites...", qq[
<img src="$web_url/working.gif">
]);



print qq[

<html>

<head>
<title>Crawler</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/pcrawl4.cgi?threads=$threads&timeout=$timeout&googlenr=$googlenr&keywords=$keywords&ccid=$ccid&nrfiles=$nrfiles&lastpos=$lastpos&&metadiz=$metadiz&metakeyw=$metakeyw">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>


];

}
else
{


$hbox = acs::get_heading_box("$web_url/ic_crawl.gif", "Problem", qq[

<p><span class="normaltext">I did not find any URLs at google.com - This might be due to the following reasons: 
</span>
<ul>
  <li class="normaltext">A firewall on your server might be blocking outside connections from Perl scripts </li>
  <li class="normaltext">Your internet connection may be down </li>
  <li class="normaltext">You don't have the latest version of the LWP::Simple Perl module installed </li>
  <li class="normaltext">Google.com banned the IP address where you are coming from </li>
</ul>

<p class="normaltext"><a href="$admin_url/p_crawl.cgi?fct=start2">Click here to continue </a></p>
]);

print qq[

<html>
<head>
<title>Crawler</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];


}


}








sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

